<?php

namespace Teknisa\FIS\Factories;

use Doctrine\ORM\EntityManager;

class Fis08600ParametrosIntegracaoFechamentoCupomFactory {

    protected $connection;

    public function __construct(EntityManager $entityManager) {
        $this->connection = $entityManager->getConnection();
    }

    public function verificaFilialParavend($cdfilial ,$nrorg){
        #sets parameter data
        $params             = array();
        $params['CDFILIAL'] = $cdfilial;
        $params['NRORG']    = $nrorg;
        #defines function query
        $sql = "SELECT  *  FROM  PARAVEND
                WHERE CDFILIAL  = :CDFILIAL
                      AND NRORG  = :NRORG";

        #prepares query and executes it with parameters
        $std = $this->connection->prepare($sql);
        $std->execute($params);

        #fetch all result rows and returns
        return $std->fetchAll();
    }

    public function insereParavend($cdfilial ,$nrorg, $cdparavend){
        #sets parameter data
        $params               = array();
        $params['CDFILIAL']   = $cdfilial;
        $params['NRORG']      = $nrorg;
        $params['CDPARAVEND'] = $cdparavend;
        #defines function query
        $sql = "INSERT INTO PARAVEND
                  (CDFILIAL, NRORG, CDPARAVEND)
                VALUES
                  (:CDFILIAL,
                   :NRORG,
                   :CDPARAVEND
                  )";

        #prepares query and executes it with parameters
        $std = $this->connection->prepare($sql);
        $std->execute($params);
    }
    
    
    public function buscaultimoparcelamento ($params) {
        $sql = "SELECT *
            FROM TAXAADMPARC
            WHERE NUMPARCTAXA =
              (SELECT MAX(NUMPARCTAXA)
              FROM
                (SELECT M.*
                FROM TAXAADMPARC M
                WHERE NRORG      = :NRORG
                AND CDTIPORECE    = :CDTIPORECE
                )
              )
            AND NRORG     = :NRORG
            AND CDTIPORECE = :CDTIPORECE";

        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetch();
    }


    public function deletaParcelamento($params) {
        $sql = "DELETE FROM TAXAADMPARC
                    WHERE NUMPARCTAXA = :NUMPARCTAXA
                    AND CDTIPORECE = :CDTIPORECE
                    AND NRORG = :NRORG";

          #prepares query and executes it with parameters
        $std = $this->connection->prepare($sql);
        $std->execute($params);
    }
    
    public function insereparcelamento($row){
        #sets parameter data
        $params = array(
                    "CDTIPORECE"    => $row['CDTIPORECE'],
                    "VRPERCENTAXA"  => $row['VRPERCENTAXA'],
                    "NUMPARCTAXA"   => $row['NUMPARCTAXA']
                );
        #defines function query
        $sql = "Insert into TAXAADMPARC (CDTIPORECE,VRPERCENTAXA,NUMPARCTAXA) 
            values (:CDTIPORECE ,:VRPERCENTAXA,:NUMPARCTAXA)";

        #prepares query and executes it with parameters
        $std = $this->connection->prepare($sql);
        $std->execute($params);
    }
    
      public function buscaultimoparcelamentofilial($params) {
        $sql = "SELECT *
            FROM TAXAADMPARCFIL
            WHERE NUMPARCTAXA =
              (SELECT MAX(NUMPARCTAXA)
              FROM
                (SELECT M.*
                FROM TAXAADMPARCFIL M
                WHERE NRORG      = :NRORG
                AND CDTIPORECE    = :CDTIPORECE
                AND CDFILIAL    = :CDFILIAL
                )
              )
            AND NRORG     = :NRORG
            AND CDTIPORECE = :CDTIPORECE";

        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetch();
    }


    public function deletaParcelamentofilial($params) {
        $sql = "DELETE FROM TAXAADMPARCFIL
                    WHERE NUMPARCTAXA = :NUMPARCTAXA
                    AND CDTIPORECE = :CDTIPORECE
                    AND CDFILIAL = :CDFILIAL
                    AND NRORG = :NRORG";

          #prepares query and executes it with parameters
        $std = $this->connection->prepare($sql);
        $std->execute($params);
    }
    
    public function insereparcelamentofilial($row){
        #sets parameter data
        $params = array(
                    "CDTIPORECE"    => $row['CDTIPORECE'],
                    "VRPERCENTAXA"  => $row['VRPERCENTAXA'],
                    "CDFILIAL"      => $row['CDFILIAL'],
                    "NUMPARCTAXA"   => $row['NUMPARCTAXA']
                );
        #defines function query
        $sql = "Insert into TAXAADMPARCFIL (CDFILIAL,CDTIPORECE,VRPERCENTAXA,NUMPARCTAXA) 
            values (:CDFILIAL, :CDTIPORECE, :VRPERCENTAXA,:NUMPARCTAXA)";

        #prepares query and executes it with parameters
        $std = $this->connection->prepare($sql);
        $std->execute($params);
    }
    
    

}