<?php
namespace Teknisa\FIS\Modules\Acessorias\Factories;

use Doctrine\ORM\EntityManager;
use Zeedhi\Framework\DB\StoredProcedure\Param;
use Zeedhi\Framework\DB\StoredProcedure\StoredProcedure;

class Fis85000SpedFactory {

    protected $connection;

    public function __construct(EntityManager $entityManager) {
        $this->connection = $entityManager->getConnection();
        set_time_limit(0);
    }

    /*
     * Executa procedure para exportação de SPED Contribuições [ARQUIVO_PIS_COFINS].
     */
    public function callSpedContribuicoesProcedure($params) {
        /*
         * Chamada para tentar mudar o timeout da conexão entre o PHP e o banco
         */
        
        $procedure = new StoredProcedure($this->connection, 'ARQUIVO_PIS_COFINS');

        $procedure->addParam(new Param('P_CDLIVROMAG', Param::PARAM_INPUT, $params["CDLIVROMAG"], Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_CDEMPRESA', Param::PARAM_INPUT, $params["CDEMPRESA"], Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_DTINICIAL', Param::PARAM_INPUT, $params["DTINICIAL"], Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_DTFINAL', Param::PARAM_INPUT, $params["DTFINAL"], Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_LIVROMAG', Param::PARAM_INPUT, $params["LIVROMAG"], Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_NRSEQARQMAG', Param::PARAM_INPUT, $params["NRSEQARQMAG"], Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_VERSAO', Param::PARAM_INPUT, $params["VERSAO"], Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_INDESCRITU', Param::PARAM_INPUT, $params["INDESCRITU"], Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_IDSITUESP', Param::PARAM_INPUT, $params["IDSITUESP"], Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_NUMRECANT', Param::PARAM_INPUT, $params["NUMRECANT"], Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_ATIVIDADE', Param::PARAM_INPUT, $params["ATIVIDADE"], Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_CDINCTRIB', Param::PARAM_INPUT, $params["CDINCTRIB"], Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_INDAPROCRED', Param::PARAM_INPUT, $params["INDAPROCRED"], Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_CDTPCON', Param::PARAM_INPUT, $params["CDTPCON"], Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_CRTESCRITUR', Param::PARAM_INPUT, $params["CRTESCRITUR"], Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_TPESCRITU', Param::PARAM_INPUT, $params["TPESCRITU"], Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_TPNATJURPJ', Param::PARAM_INPUT, $params["TPNATJURPJ"], Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_GERABCLP', Param::PARAM_INPUT, $params["GERABCLP"], Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_NATUJURID', Param::PARAM_INPUT, $params["NATUJURID"], Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_FORAPRAZO', Param::PARAM_INPUT, $params["FORAPRAZO"], Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_IDCONSPRODEXT', Param::PARAM_INPUT, $params["IDCONSPRODEXT"], Param::PARAM_TYPE_STR));

        $output = $procedure->execute();
    }

    /*
     * Executa procedure para exportação de SPED Fiscal [ARQUIVO_SPED].
     */
    public function callSpedFiscalProcedure($params) {
        /*
         * Chamada para tentar mudar o timeout da conexão entre o PHP e o banco
         */
        $procedure = new StoredProcedure($this->connection, 'ARQUIVO_SPED');
        
        $procedure->addParam(new Param('P_CDIMPOSTO', Param::PARAM_INPUT, $params["CDIMPOSTO"], Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_CDEMPRESA', Param::PARAM_INPUT, $params["CDEMPRESA"], Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_CDINSCESTA', Param::PARAM_INPUT, $params["CDINSCESTA"], Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_CDINSCMUNI', Param::PARAM_INPUT, $params["CDINSCMUNI"], Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_DTINICIAL', Param::PARAM_INPUT, $params["DTINICIAL"], Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_DTFINAL', Param::PARAM_INPUT, $params["DTFINAL"], Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_LIVROMAG', Param::PARAM_INPUT, $params["LIVROMAG"], Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_TIPO', Param::PARAM_INPUT, $params["TIPO"], Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_FINALIDADE', Param::PARAM_INPUT, $params["FINALIDADE"], Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_INDESCRITU', Param::PARAM_INPUT, $params["INDESCRITU"], Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_PERFIL', Param::PARAM_INPUT, $params["PERFIL"], Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_ATIVIDADE', Param::PARAM_INPUT, $params["ATIVIDADE"], Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_VERSAO', Param::PARAM_INPUT, $params["VERSAO"], Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_NRSEQARQMAG', Param::PARAM_INPUT, $params["NRSEQARQMAG"], Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_BLOCOH', Param::PARAM_INPUT, $params["BLOCOH"], Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_H020', Param::PARAM_INPUT, $params["H020"], Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_DTINIPER', Param::PARAM_INPUT, $params["DTINIPER"], Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_DTFINPER', Param::PARAM_INPUT, $params["DTFINPER"], Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_IDDIFALIQ', Param::PARAM_INPUT, $params["IDDIFALIQ"], Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_GERAFORSALE', Param::PARAM_INPUT, $params["GERAFORSALE"], Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_MOTINV', Param::PARAM_INPUT, $params["MOTINV"], Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_OBRIGREGBL1', Param::PARAM_INPUT, $params["OBRIGREGBL1"], Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_CDLIVROMAGADIC', Param::PARAM_INPUT, $params["CDLIVROMAGADIC"], Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_IDORIGLIVROADIC', Param::PARAM_INPUT, $params["IDORIGLIVROADIC"], Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_DTINIVAF', Param::PARAM_INPUT, $params["DTINIVAF"], Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_DTFINVAF', Param::PARAM_INPUT, $params["DTFINVAF"], Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_GERABLOCOK', Param::PARAM_INPUT, $params["GERABLOCOK"], Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_ORIGBLOCOK', Param::PARAM_INPUT, $params["ORIGBLOCOK"], Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_AGRUPPROD', Param::PARAM_INPUT, $params["AGRUPPROD"], Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_CDINSCENTR', Param::PARAM_INPUT, $params["CDINSCENTR"], Param::PARAM_TYPE_STR));
        
        $procedure->addParam(new Param('P_IDCLASSIFICESTAB', Param::PARAM_INPUT, $params["IDCLASSIFICESTAB"], Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_IDINFCOMPLST', Param::PARAM_INPUT, $params["IDINFCOMPLST"], Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_NRDIAMEDIAEST', Param::PARAM_INPUT, $params["NRDIAMEDIAEST"], Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_IDGERACAMPO11ST', Param::PARAM_INPUT, $params["IDGERACAMPO11ST"], Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_IDCONSPRODEST', Param::PARAM_INPUT, $params["IDCONSPRODEST"], Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_IDCONSPRODEXT', Param::PARAM_INPUT, $params["IDCONSPRODEXT"], Param::PARAM_TYPE_STR));
   
        $procedure->execute();
    }

    /*
     * Função para excluir os dados gerados na procedure de SPED Contribuições.
     */
    public function deleteSpedContribuicoesData($params) {
        // Query a ser executada.
        $sql = "DELETE FROM ARQMAGPISCOFINS WHERE NRSEQARQMAG = :NRSEQARQMAG AND NRORG = :NRORG";

        // Prepara o statement da query para execução.
        $statement = $this->connection->prepare($sql);

        // Executa o statement com os paràmetros passados.
        $statement->execute($params);
    }

    /*
     * Função para excluir os dados gerados na procedure de SPED Fiscal.
     */
    public function deleteSpedFiscalData($params) {
        // Query a ser executada.
        $sql = "DELETE FROM ARQMAGNETICO WHERE NRSEQARQMAG = :NRSEQARQMAG AND NRORG = :NRORG";

        // Prepara o statement da query para execução.
        $statement = $this->connection->prepare($sql);

        // Executa o statement com os paràmetros passados.
        $statement->execute($params);
    }

    /*
     * Função para retornar a sigla do estado relacionado a uma inscrição estadual.
     */
    public function getEstadoInscricaoEstadual($params) {
        // Query a ser executada.
        $sql = "SELECT SGESTADO FROM INSCRESTAD WHERE CDEMPRESA = :CDEMPRESA AND CDINSCESTA = :CDINSCESTA AND NRORG = :NRORG";

        // Prepara o statement da query para execução.
        $statement = $this->connection->prepare($sql);

        // Executa o statement com os paràmetros passados.
        $statement->execute($params);

        // Executa um fetch no primeiro dado, retornando-o.
        return $statement->fetch(\PDO::FETCH_ASSOC);
    }

    /*
     * Função para retornar os parâmetros de SPED Contribuições para uma empresa.
     */
    public function getParametrosSpedContribuicoes($params) {
        // Query a ser executada.
        $sql = "SELECT CDTELA, CDEMPRESA, CDINSCRICAO, NRORG, CDCAMPO1 AS STFINALIDADE, CDCAMPO2 AS STIDSITESP, CDCAMPO3 AS STRECANT, CDCAMPO4 AS IDATIV, CDCAMPO5 AS STINCTRIB, CDCAMPO6 AS STAPROCRED, CDCAMPO7 AS STTPCONTR, CDCAMPO8 AS STVERSAO, CDCAMPO9 AS STBLOCOP, CDCAMPO10 AS STCRTESCRIT, CDCAMPO11 AS STNATUJUR, CDCAMPO12 AS IDFORAPER, CDCAMPO13 AS IDCONSPRODEXT FROM PARAMDECLACES WHERE CDTELA = 'FIS95000' AND CDEMPRESA = :CDEMPRESA AND NRORG = :NRORG AND CDINSCRICAO = 'FEDERAL'";

        // Prepara o statement da query para execução.
        $statement = $this->connection->prepare($sql);

        // Executa o statement com os paràmetros passados.
        $statement->execute($params);

        // Executa um fetch no primeiro dado, retornando-o.
        return $statement->fetch(\PDO::FETCH_ASSOC);
    }

    /*
     * Função para retornar os parâmetros de SPED Fiscal para uma empresa e uma
     * inscrição estadual.
     */
    public function getParametrosSpedFiscal($params) {
        // Query a ser executada.
        $sql = "SELECT * FROM DADOSGERSPED WHERE CDEMPRESA = :CDEMPRESA AND CDINSCESTA = :CDINSCESTA AND NRORG = :NRORG";

        // Prepara o statement da query para execução.
        $statement = $this->connection->prepare($sql);

        // Executa o statement com os paràmetros passados.
        $statement->execute($params);

        // Executa um fetch no primeiro dado, retornando-o.
        return $statement->fetch(\PDO::FETCH_ASSOC);
    }

    /*
     * Função para retornar os dados gerados na procedure de SPED Contribuições.
     */
    public function getSpedContribuicoesData($params) {
        // Query a ser executada.
        $sql = "SELECT NRORDREGARQMAG, DSREGARQMAG FROM ARQMAGPISCOFINS WHERE NRSEQARQMAG = :NRSEQARQMAG AND NRORG = :NRORG ORDER BY NRORDREGARQMAG";

        // Prepara o statement da query para execução.
        $statement = $this->connection->prepare($sql);

        // Executa o statement com os paràmetros passados.
        $statement->execute($params);

        // Executa um fetch no primeiro dado, retornando-o.
        return $statement->fetchAll();
    }
    
    public function getSpedContribuicoesPeriod($params) {
        // Query a ser executada.
        $sql = "SELECT LINHA, NRSEQARQMAG, NRORDREGARQ, DSREGARQMAG FROM ( SELECT ROWNUM AS LINHA, NRSEQARQMAG, NRORDREGARQ, DSREGARQMAG FROM ( SELECT NRSEQARQMAG, NRORDREGARQMAG AS NRORDREGARQ, DSREGARQMAG FROM ARQMAGPISCOFINS WHERE NRSEQARQMAG =:NRSEQARQMAG AND NRORG =:NRORG ORDER BY NRORDREGARQMAG ) ) WHERE LINHA >= :INICIO AND LINHA <= :FIM";

        // Prepara o statement da query para execução.
        $statement = $this->connection->prepare($sql);

        // Executa o statement com os paràmetros passados.
        $statement->execute($params);

        // Executa um fetch no primeiro dado, retornando-o.
        return $statement->fetchAll();
    }

    /*
     * Função para retornar os dados gerados na procedure de SPED Fiscal.
     */
    public function getSpedFiscalData($params) {
        // Query a ser executada.
        $sql = "SELECT NRSEQARQMAG, NRORDREGARQ, DSREGARQMAG as DSREGARQMAG FROM ARQMAGNETICO WHERE NRSEQARQMAG = :NRSEQARQMAG AND NRORG = :NRORG ORDER BY NRORDREGARQ, SUBSTR(DSREGARQMAG,1,17)";

        // Prepara o statement da query para execução.
        $statement = $this->connection->prepare($sql);

        // Executa o statement com os paràmetros passados.
        $statement->execute($params);

        // Executa um fetch no primeiro dado, retornando-o.
        return $statement->fetchAll();
    }
    
    public function getSpedFiscalDataPeriod($params) {
        // Query a ser executada.
        $sql = "SELECT LINHA, NRSEQARQMAG, NRORDREGARQ, DSREGARQMAG FROM ( SELECT ROWNUM AS LINHA, NRSEQARQMAG, NRORDREGARQ, DSREGARQMAG FROM ( SELECT NRSEQARQMAG, NRORDREGARQ, DSREGARQMAG AS DSREGARQMAG FROM ARQMAGNETICO WHERE NRSEQARQMAG =:NRSEQARQMAG AND NRORG =:NRORG ORDER BY NRORDREGARQ, SUBSTR(DSREGARQMAG,1,17) ) ) WHERE LINHA >= :INICIO AND LINHA <= :FIM";

        // Prepara o statement da query para execução.
        $statement = $this->connection->prepare($sql);

        // Executa o statement com os paràmetros passados.
        $statement->execute($params);

        // Executa um fetch no primeiro dado, retornando-o.
        return $statement->fetchAll();
    }
    
    public function getSpedFiscalInscEsta($row) {
        // Query a ser executada.
        $sql = "SELECT CDINSCESTA FROM INSCRESTAD WHERE CDEMPRESA = :CDEMPRESA";

        $params = array(
            'CDEMPRESA' => $row['CDEMPRESA']
        );
        
        // Prepara o statement da query para execução.
        $std = $this->connection->prepare($sql);
        
        // Executa o statement com os paràmetros passados.
        $std->execute($params);
        
        // Executa um fetch no primeiro dado, retornando-o.
        return $std->fetchAll();
    }
    
    public function getSpedContEmpresa() {
        // Query a ser executada.
        $sql = "SELECT CDEMPRESA FROM EMPRESA ORDER BY CDEMPRESA";

        // Prepara o statement da query para execução.
        $std = $this->connection->prepare($sql);
        
        // Executa o statement com os paràmetros passados.
        $std->execute();
        
        // Executa um fetch no primeiro dado, retornando-o.
        return $std->fetchAll();
    }
    
    public function insertAgendamentoSped($row) {
        $sql = "INSERT INTO AGENDOBRIGACESS
            ( 
                NRORG,
                NRAGENDAMENTO,
                CDTELA,
            	CDEMPRESA,
                CDINSCESTA,
            	DTAGENDAMENTO,
            	DTINICIAL,
            	DTFINAL,
            	IDPERIAGEN,
            	CDCAMPO1,
                CDCAMPO2,
                CDCAMPO3,
                DTCAMPO1,
                DTCAMPO2  ) 
             VALUES (
                :NRORG,
                :NRAGENDAMENTO,
                :CDTELA,
                :CDEMPRESA,
                :CDINSCESTA,
                :DTAGENDAMENTO,
                :DTINICIAL,
                :DTFINAL,
                :IDPERIAGEN,
                :CDCAMPO1,
                :CDCAMPO2,
                :CDCAMPO3,
                :DTCAMPO1,
                :DTCAMPO2   )";
        
        $params = array(
            "NRORG"=>$row["NRORG"],
            "NRAGENDAMENTO"=>$row["NRAGENDAMENTO"],
            "CDTELA"=>$row["CDTELA"],
            "CDEMPRESA"=>$row["CDEMPRESA"],
            "CDINSCESTA"=>$row["CDINSCESTA"],
            "DTAGENDAMENTO"=>$row["DTAGENDAMENTO"],
            
            //Campos da tabela que serão salvos e os campos da declaração
            "DTINICIAL"=>$row["DTINICIAL"],
            "DTFINAL"=>$row["DTFINAL"],
            "IDPERIAGEN"=>$row["IDPERIAGEN"],
            "CDCAMPO1"=>$row["CDLIVROMAG"],
            "CDCAMPO2"=>$row["IDGERABLOCOH"],
            "CDCAMPO3"=>$row["CDMOTINVENTARIO"],
            "DTCAMPO1"=>$row["DTINIPERFISC"],
            "DTCAMPO2"=>$row["DTFINPERFISC"]
        );
        
        $std = $this->connection->prepare($sql);
        $std->execute($params);
    }
    
    public function updateAgendamentoSped($row) {
        $sql = "UPDATE AGENDOBRIGACESS
                    SET CDEMPRESA = :CDEMPRESA,
                        CDINSCESTA = :CDINSCESTA,
                    	DTAGENDAMENTO = :DTAGENDAMENTO,
                    	DTINICIAL = :DTINICIAL,
                    	DTFINAL = :DTFINAL,
                    	IDPERIAGEN = :IDPERIAGEN,
                    	CDCAMPO1 = :CDCAMPO1,
                        CDCAMPO2 = :CDCAMPO2,
                        CDCAMPO3 = :CDCAMPO3,
                        DTCAMPO1 = :DTCAMPO1,
                        DTCAMPO2 = :DTCAMPO2
                    WHERE NRAGENDAMENTO = :NRAGENDAMENTO
                    AND CDTELA = :CDTELA";
        
        $params = array(
            "NRAGENDAMENTO"=>$row["NRAGENDAMENTO"],
            "CDTELA"=>$row["CDTELA"],
            "CDEMPRESA"=>$row["CDEMPRESA"],
            "CDINSCESTA"=>$row["CDINSCESTA"],
            "DTAGENDAMENTO"=>$row["DTAGENDAMENTO"],
            
            //Campos da tabela que serão salvos e os campos da declaração
            "DTINICIAL"=>$row["DTINICIAL"],
            "DTFINAL"=>$row["DTFINAL"],
            "IDPERIAGEN"=>$row["IDPERIAGEN"],
            "CDCAMPO1"=>$row["CDLIVROMAG"],
            "CDCAMPO2"=>isset($row["IDGERABLOCOH"]) ? $row["IDGERABLOCOH"] : null,
            "CDCAMPO3"=>isset($row["CDMOTINVENTARIO"]) ? $row["CDMOTINVENTARIO"] : null,
            "DTCAMPO1"=>isset($row["DTINIPERFISC"]) ? $row["DTINIPERFISC"] : null,
            "DTCAMPO2"=>isset($row["DTFINPERFISC"]) ? $row["DTFINPERFISC"] : null
        );
        
        $std = $this->connection->prepare($sql);
        $std->execute($params);
    }
    
    public function updateAgendamentoIdStatus($row, $idstatus) {
        $sql = "UPDATE AGENDOBRIGACESS
                    SET IDSTATUS = :IDSTATUS
                    WHERE NRAGENDAMENTO = :NRAGENDAMENTO
                    AND CDTELA = :CDTELA";
                    
        $params = array(
            "NRAGENDAMENTO"=>$row["NRAGENDAMENTO"],
            "CDTELA"=>$row["CDTELA"],
            "IDSTATUS"=>$idstatus
        );
        
        $std = $this->connection->prepare($sql);
        $std->execute($params);
    }
    
    public function getAgendamentoSpedInsert($row) {
        // Query a ser executada.
        $sql = "SELECT * FROM AGENDOBRIGACESS 
                    WHERE NRAGENDAMENTO = :NRAGENDAMENTO";

        $params = array(
            "NRAGENDAMENTO"=>$row["NRAGENDAMENTO"]
        );
        
        // Prepara o statement da query para execução.
        $std = $this->connection->prepare($sql);
        
        // Executa o statement com os paràmetros passados.
        $std->execute($params);
        
        // Executa um fetch no primeiro dado, retornando-o.
        return $std->fetchAll();
    }
   
    public function findAgendamento() {
        // Query a ser executada.
        $sql = "SELECT 
                    A.NRORG,
                    A.NRAGENDAMENTO,
                    A.CDTELA,
                    A.CDEMPRESA,
                    E.NMEMPRESA,
                    A.CDINSCESTA,
                    A.DTAGENDAMENTO,
                    A.DTINICIAL,
                    A.DTFINAL,
                    A.IDPERIAGEN,
                    A.CDCAMPO1 AS CDLIVROMAG,
                    L.NMLIVROMAG,
                    A.CDCAMPO2 AS IDGERABLOCOH,
                    A.CDCAMPO3 AS CDMOTINVENTARIO,
                    A.DTCAMPO1 AS DTINIPERFISC,
                    A.DTCAMPO2 AS DTFINPERFISC,
                    DECODE(A.IDPERIAGEN, '0', A.DTINICIAL,
                                           '1', TO_CHAR(SYSDATE, 'DD/MM/YYYY'),
                                           '2', TO_CHAR(ADD_MONTHS(SYSDATE,(-1)), 'DD/MM/YYYY')) AS DTREFINI,
                    A.IDSTATUS
                    FROM AGENDOBRIGACESS A,
                    EMPRESA E,
                    LIVROMAGNETICO L
                    WHERE CDTELA  = 'FIS85000'
                    AND A.CDEMPRESA = E.CDEMPRESA
                    AND A.CDCAMPO1 = L.CDLIVROMAG
                UNION ALL
                SELECT 
                    A.NRORG,
                    A.NRAGENDAMENTO,
                    A.CDTELA,
                    A.CDEMPRESA,
                    '' AS NMEMPRESA,
                    A.CDINSCESTA,
                    A.DTAGENDAMENTO,
                    A.DTINICIAL,
                    A.DTFINAL,
                    A.IDPERIAGEN,
                    A.CDCAMPO1 AS CDLIVROMAG,
                    L.NMLIVROMAG,
                    A.CDCAMPO2 AS IDGERABLOCOH,
                    A.CDCAMPO3 AS CDMOTINVENTARIO,
                    A.DTCAMPO1 AS DTINIPERFISC,
                    A.DTCAMPO2 AS DTFINPERFISC,
                    DECODE(A.IDPERIAGEN, '0', DTINICIAL,
                                           '1', TO_CHAR(SYSDATE, 'DD/MM/YYYY'),
                                           '2', TO_CHAR(ADD_MONTHS(SYSDATE,(-1)), 'DD/MM/YYYY')) AS DTREFINI,
                    A.IDSTATUS
                    FROM AGENDOBRIGACESS A,
                    LIVROMAGNETICO L
                    WHERE CDTELA  = 'FIS95000'
                    AND A.CDCAMPO1 = L.CDLIVROMAG";

        // Prepara o statement da query para execução.
        $std = $this->connection->prepare($sql);
        
        // Executa o statement com os paràmetros passados.
        $std->execute();
        
        // Executa um fetch no primeiro dado, retornando-o.
        return $std->fetchAll();
    }
    
    public function findAgendamentoExec($row) {
        // Query a ser executada.
        $sql = "SELECT 
                    TO_CHAR(SYSDATE, 'DD/MM/YYYY HH24:MI') AS DTATUAL,
                    TO_CHAR(ADD_MONTHS(SYSDATE,(-1)), 'DD/MM/YYYY HH24:MI') AS LAST_MONTH,
                    A.NRAGENDAMENTO,
                    A.CDTELA,
                    A.CDEMPRESA,
                    A.CDINSCESTA,
                    A.DTAGENDAMENTO,
                    A.DTINICIAL,
                    A.DTFINAL,
                    A.IDPERIAGEN,
                    A.CDCAMPO1 AS CDLIVROMAG,
                    L.NMLIVROMAG,
                    A.CDCAMPO2 AS IDGERABLOCOH,
                    A.CDCAMPO3 AS CDMOTINVENTARIO,
                    A.DTCAMPO1 AS DTINIPERFISC,
                    A.DTCAMPO2 AS DTFINPERFISC,
                    A.DTINICIAL AS DTREFINI,
                    A.IDSTATUS
                    FROM AGENDOBRIGACESS A,
                    LIVROMAGNETICO L
                    WHERE NRAGENDAMENTO = :NRAGENDAMENTO
                    AND A.CDCAMPO1 = L.CDLIVROMAG";
        
        $params = array(
            "NRAGENDAMENTO"=> $row["NRAGENDAMENTO"]
        );
        
        // Prepara o statement da query para execução.
        $std = $this->connection->prepare($sql);
        
        // Executa o statement com os paràmetros passados.
        $std->execute($params);
        
        // Executa um fetch no primeiro dado, retornando-o.
        //var_dump($std->fetchAll());
        return $std->fetchAll();
    }
    
    public function getNmEmpresa($row) {
        // Query a ser executada.
        $sql = "SELECT NMEMPRESA FROM EMPRESA
                    WHERE CDEMPRESA = :CDEMPRESA
                    AND NRORG = :NRORG";
        
        $params = array(
            "CDEMPRESA"=> $row["CDEMPRESA"],
            "NRORG"=> $row["NRORG"]
        );
        
        // Prepara o statement da query para execução.
        $std = $this->connection->prepare($sql);
        
        // Executa o statement com os paràmetros passados.
        $std->execute($params);
        
        // Executa um fetch no primeiro dado, retornando-o.
        //var_dump($std->fetchAll());
        return $std->fetch();
    }
    
    public function insertAgendamentoArquivoSped($row) {
        $sql = "INSERT INTO ARQUIOBRIGACESS
            ( 
                NRORG,
                NRARQUIVO,
                NRAGENDAMENTO,
                CDTELA,
                CDEMPRESA,
                CDINSCESTA,
                DTAGENDAMENTO,
                DTEXECAGEND,
                NMARQUIVO,
                NMPATHARQ
            )
             VALUES (
                :NRORG,
                :NRARQUIVO,
                :NRAGENDAMENTO,
                :CDTELA,
                :CDEMPRESA,
                :CDINSCESTA,
                :DTAGENDAMENTO,
                :DTEXECAGEND,
                :NMARQUIVO,
                :NMPATHARQ  )";
        
        $params = array(
            "NRORG" => $row["NRORG"],
            "NRARQUIVO" => $row["NRARQUIVO"],
            "NRAGENDAMENTO" => $row["NRAGENDAMENTO"],
            "CDTELA" => $row["CDTELA"],
            "CDEMPRESA" => $row["CDEMPRESA"],
            "CDINSCESTA" => $row["CDINSCESTA"],
            "DTAGENDAMENTO" => $row["DTAGENDAMENTO"],
            "DTEXECAGEND" => $row["DTEXECAGEND"],
            "NMARQUIVO" => $row["NMARQUIVO"],
            "NMPATHARQ" => $row["NMPATHARQ"]
            
        );
        
        $std = $this->connection->prepare($sql);
        $std->execute($params);
    }
    
    public function getAgendamentoArquivoSped($row) {
        $sql = "SELECT * FROM ARQUIOBRIGACESS
                WHERE NRAGENDAMENTO = :NRAGENDAMENTO";
        
        $params = array(
            "NRAGENDAMENTO" => $row["NRAGENDAMENTO"]
        );
        
        // Prepara o statement da query para execução.
        $std = $this->connection->prepare($sql);
        
        // Executa o statement com os paràmetros passados.
        $std->execute($params);
        
        // Executa um fetch no primeiro dado, retornando-o.
        return $std->fetchAll();
    }
    
    public function verAgendamentoArquivoSped($row) {
        $sql = "SELECT * FROM ARQUIOBRIGACESS
                WHERE NRAGENDAMENTO = :NRAGENDAMENTO
                AND NMARQUIVO = :NMARQUIVO";
        
        $params = array(
            "NRAGENDAMENTO" => $row["NRAGENDAMENTO"],
            "NMARQUIVO" => $row["NMARQUIVO"]
        );
        
        // Prepara o statement da query para execução.
        $std = $this->connection->prepare($sql);
        
        // Executa o statement com os paràmetros passados.
        $std->execute($params);
        
        // Executa um fetch no primeiro dado, retornando-o.
        return $std->fetchAll();
    }
    
    public function deleteAgendamentoArquivoSped($row) {
        $sql = "DELETE FROM ARQUIOBRIGACESS
                WHERE NRAGENDAMENTO = :NRAGENDAMENTO";
        
        $params = array(
            "NRAGENDAMENTO" => $row["NRAGENDAMENTO"]
        );
        
        // Prepara o statement da query para execução.
        $std = $this->connection->prepare($sql);
        
        // Executa o statement com os paràmetros passados.
        $std->execute($params);
        
    }
  
    public function deleteAgendamentoSped($row) {
        // Query a ser executada.
        $sql = "DELETE FROM AGENDOBRIGACESS 
                    WHERE NRAGENDAMENTO = :NRAGENDAMENTO";

        $params = array(
            "NRAGENDAMENTO"=>$row["NRAGENDAMENTO"]
        );
        
        // Prepara o statement da query para execução.
        $std = $this->connection->prepare($sql);
        
        // Executa o statement com os paràmetros passados.
        $std->execute($params);
        
    }
    
    public function getConfiguraSMTP($row)  {
        // Query a ser executada.
        $sql = "SELECT * FROM CONFIGURASMTP
                    WHERE NRORG = :NRORG";
        
        $params = array(
            "NRORG"=> $row["NRORG"]
        );
        // Prepara o statement da query para execução.
        $std = $this->connection->prepare($sql);
        
        // Executa o statement com os paràmetros passados.
        $std->execute($params);
        
        // Executa um fetch no primeiro dado, retornando-o.
        //var_dump($std->fetchAll());
        return $std->fetchAll();
    }
    
    public function getContatos($row)  {
        // Query a ser executada.
        $sql = "SELECT * FROM CONTATOAPURAC
                    WHERE NRORG = :NRORG
                    AND CDEMPRESA = :CDEMPRESA
                    AND IDEXPORTAUTO = 'S'";
        
        $params = array(
            "NRORG"=> $row["NRORG"],
            "CDEMPRESA"=> $row["CDEMPRESA"]
        );
        // Prepara o statement da query para execução.
        $std = $this->connection->prepare($sql);
        
        // Executa o statement com os paràmetros passados.
        $std->execute($params);
        
        // Executa um fetch no primeiro dado, retornando-o.
        //var_dump($std->fetchAll());
        return $std->fetchAll();
    }
    
    public function deleteArquivo($row) {
        $sql = "DELETE FROM ARQUIOBRIGACESS
                WHERE NRAGENDAMENTO = :NRAGENDAMENTO
                AND NRARQUIVO = :NRARQUIVO";
        
        $params = array(
            "NRAGENDAMENTO" => $row["NRAGENDAMENTO"],
            "NRARQUIVO" => $row["NRARQUIVO"]
        );
        
        // Prepara o statement da query para execução.
        $std = $this->connection->prepare($sql);
        
        // Executa o statement com os paràmetros passados.
        $std->execute($params);
        
    }
}